var main_webos = {
    orientation : "H"
}

var player = null;
var transfer = false;
var manager = false;
var timerService = null;
var package_version = ""; // Bundle version admira.ver in package
var local_version = ""; // Bundle version admira.ver as external installation (updated from platform)

$(document).ready(function(){
    /* ENABLE DEBUG
    var configuration = new Configuration();

    var options = {};
    options.enabled = true; //enabling debug mode

    configuration.debug(function successCb() {
        console.log("Succeeded to enable the debug mode");
    },function failureCb() {
        console.log("Failed to enable the debug mode");
    },options);
    */

    try{
      if(document.location != "file:///media/internal/webos.html"){
        $.get('/media/internal/webos.html', function(data, status) {
            $("#starter").html("File request status: "+status);
        }).done(function() {
            $("#starter").html("Checking Build Version");
            $.get('./admira.ver', function(data, status) {
                package_version = data;
                package_version = package_version.replace(/\D/g,"");
                package_version = parseInt(package_version);
                if(!isNaN(package_version)){
                  $("#starter").html("Package Admira.ver : "+package_version);
                  $.get('/media/internal/admira.ver', function(local_data, status) {
                    local_version = local_data;
                    local_version = local_version.substr(0,9);
                    local_version = local_version.replace(/\D/g,"");
                    local_version = parseInt(local_version);
                    if(!isNaN(local_version)){
                      $("#starter").html("Package Version : "+package_version+" Local Version : "+local_version);
                      if(package_version > local_version){
                        setTimeout(function(){
                          initApplication();
                        },3000);
                      }else{
                        $("#starter").html("System is updatable. -- todo ha ido bien. Ejecutamos webos.html");
                        document.location ="/media/internal/webos.html";
                      }
                    }else{
                      $("#starter").html("Starting package version : "+package_version);
                      initApplication();
                    }
                  }).fail(function(e) {
                    $("#starter").html("Starting package version : "+package_version);
                    initApplication();
                  });
                }else{
                  $("#starter").html("Starting package version : "+package_version);
                  initApplication();
                }
            }).fail(function(e) {
              $("#starter").html("Starting package version.");
              initApplication();
            });
        }).fail(function(e) {
            $("#starter").html("entramos en fail");
            var systemInfo = navigator.userAgent || navigator.vendor || window.opera;
            systemInfo = systemInfo.toLowerCase();
            var html_base = '/media/cryptofs/apps/usr/palm/services/com.lg.app.signage.webos/app/webos2.html';

            var custom = new Custom();
            custom.Signage.getwebOSVersion(
                function successCallback(successObject) {
                    console.log('webOS Signage version: ' + successObject.webOSVersion)
                    $("#starter").html(successObject.webOSVersion);
                    //if(systemInfo.match(/chrome/i)){
                    if(successObject.webOSVersion != "2.0"){
                      // WEBOS 3
                      html_base = '/media/cryptofs/apps/usr/palm/services/com.lg.app.signage.webos/app/webos3.html';
                    }
                    $.get(html_base, function(data, status) {
                        $("#starter").html("File request status: "+status);
                    }).done(function() {
                        $("#starter").html("System is updatable. --> "+successObject.webOSVersion);
                       document.location =html_base;
                    }).fail(function(e) {
                      $("#starter").html("Starting package version."+successObject.webOSVersion);
                      initApplication();
                    });
                },
                function failureCallback(failureObject) {
                    $.get(html_base, function(data, status) {
                        $("#starter").html("File request status: "+status);
                    }).done(function() {
                        $("#starter").html("System is updatable. --"+ JSON.stringify(failureObject));
                       document.location =html_base;
                    }).fail(function(e) {
                      $("#starter").html("Starting package version.");
                      initApplication();
                    });
                }
            );
        });
      }else{
        initApplication();
      }
    }catch(e){
      initApplication();
    }
});

function initApplication(){
  try{
    if(!player){
        player = new PlayerController();
        $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
        player.init();
    }
  }catch(e){
    $("#starter").html("System in recovery mode.");
    console.log("Unable to start player");
    var archive = [];
    try{
      archive = player.dataManager.getArchiveFiles();
    }catch(e){
      console.log("No Archive !");
    }
    var schedule = undefined;

    try{
      if(!transfer){
          transfer = new TransferService();
          transfer.setTimeCallback = player.setUseServerTime;
          transfer.init(player.version);
      }
      transfer.activateLogger(player.debug);
      transfer.update(player.timestamp,archive);
    }catch(e){
      console.log("Unable to start transfer");
    }
    try{
      schedule = player.config.getScheduleConfig();
    }catch(e){
      console.log("No Schedule !");
    }
    try{
      if(!manager){
          manager = new ManagerService();
          manager.init();
      }
      manager.activateLogger(player.debug);
      manager.update(schedule);
    }catch(e){
      console.log("Unable to start manager");
    }
  }
};

function onPlayerDataLoaded(){
  $("#starter").hide();
  setTimeout(function(){
    var archive = [];
    try{
      archive = player.dataManager.getArchiveFiles();
    }catch(e){
      console.log("No Archive !");
    }
    var schedule = undefined;

    try{
      if(!transfer){
          transfer = new TransferService();
          transfer.setTimeCallback = player.setUseServerTime;
          transfer.init(player.version);
      }
      transfer.activateLogger(player.debug);
      transfer.update(player.timestamp,archive);
    }catch(e){
      console.log("Unable to start transfer");
    }
    try{
      schedule = player.config.getScheduleConfig();
    }catch(e){
      console.log("No Schedule !");
    }
    try{
      if(!manager){
          manager = new ManagerService();
          manager.init();
      }
      manager.activateLogger(player.debug);
      manager.update(schedule);
    }catch(e){
      console.log("Unable to start manager");
    }
    setTimeout(function(){transfer.OS.insertTimersOrReboot(player.config.getForceReboot24h());}, 10000);
    transfer.OS.clearCache();
    setInterval(function(){transfer.OS.clearCache();}, 7200000);
    transfer.OS.setPictureProperty();
    setInterval(function(){transfer.OS.setPictureProperty();}, 7200000);
    if(!timerService){
        timerService = new TimerService();
    }
    timerService.checkTimers(schedule);
  }, 5000);
}

$(document).on("keydown",function(event){
    var keyCode = event.keyCode;
    player.log("WebOS Keydown : "+keyCode);
    switch (keyCode) {
        //case 37:
            //player.playlist.jump(-1);
        //    break;
        //case 39:
        //    player.playlist.jump();
        //    break;
        case 38:
            player.debug = !player.debug;
            try{
              player.setLogger($("#playerLog"));
              player.activateLogger(player.debug);
            }catch(e){
              console.log("Error on player toggle debug");
            }
            try{
              transfer.setLogger($("#transferLog"));
              transfer.activateLogger(player.debug);
              manager.setLogger($("#transferLog"));
            }catch(e){
              console.log("Error on transfer toggle debug");
            }
            break;
        //case 13:
        //    player.update();
        //    break;
        case 406:
            try{
              player.OS.upgradeApplicationNow();
            }catch(e){
              console.log("Error on player App update");
              try{
                transfer.OS.upgradeApplicationNow();
              }catch(e){
                  console.log("Error on transfer App update");
              }
            }
            break;
        default:
            player.log("TV : Unhandled key");
            break;
    }
});
